#if 0 

    Copyright (c) 1991 SGI   All Rights Reserved
    THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SGI
    The copyright notice above does not evidence any
    actual or intended publication of such source code,
    and is an unpublished work by Silicon Graphics, Inc.
    This material contains CONFIDENTIAL INFORMATION that
    is the property of Silicon Graphics, Inc. Any use,
    duplication or disclosure not specifically authorized
    by Silicon Graphics is strictly prohibited.
    
    RESTRICTED RIGHTS LEGEND:
    
    Use, duplication or disclosure by the Government is
    subject to restrictions as set forth in subdivision
    (c)(1)(ii) of the Rights in Technical Data and Computer
    Software clause at DFARS 52.227-7013, and/or in similar
    or successor clauses in the FAR, DOD or NASA FAR
    Supplement.  Unpublished- rights reserved under the
    Copyright Laws of the United States.  Contractor is
    SILICON GRAPHICS, INC., 2011 N. Shoreline Blvd.,
    Mountain View, CA 94039-7311

#endif
/*
    This class is an interface to the user mode semaphore services.
*/
#ifndef _ilSemaphore_h_
#define _ilSemaphore_h_

#include <il/ilDefs.h>
#ifdef IL_MP
#include <ulocks.h>
#endif

class ilArena;

class ilSemaphore {
public:
    // external api: begin
    ilSemaphore(int val=1);	// create semaphore with initial count of 'val'
    ~ilSemaphore();		// free semaphore
    
    int set(int val);		// re-initialize semaphore to count of 'val'
    int inc();			// perform 'v' operation
    int dec(int wait=TRUE);	// perform 'p' operation
    // external api: end
    
    int operator=(int val) { return set(val); }
    int operator++() { return inc(); }
    int operator--() { return dec(); }
    
#ifdef DEBUG
    int test();		// Debug Only: test semaphore (return value)
#endif

protected:
    ilSemaphore(int val, ilArena* ar);
    ilSemaphore(int val, usptr_t* h);
#ifdef IL_MP
    void init(int val);

    usema_t* sem;
    usptr_t* handle;
#endif
};

#endif
